#include <alx.hpp>
#include <muus/muus.hpp>
#include <allegro5/allegro_image.h>
#include <string>
#include <iostream>

using namespace alx;
using namespace muus;
using namespace std;

extern void convert_file(const char* source, const char* dest);

void perform_loop();

int main() {
    InitAttempt(al_init());
    InitAttempt(al_install_keyboard());
    InitAttempt(al_install_mouse());
    InitAttempt(al_init_image_addon());

    int ret = ExceptionTrapVoid(perform_loop);

    return ret;
}

bool perform_once() {
    Display nulldisplay;

    NativeFileDialog openDialog {"LunaticPal: Select Image File", NULL, "*.*", ALLEGRO_FILECHOOSER_FILE_MUST_EXIST /*| ALLEGRO_FILECHOOSER_MULTIPLE*/};
    if (!openDialog.show(nulldisplay)) return false;
    if (openDialog.getSelectedFileCount() == 0) return false;

    NativeFileDialog saveDialog {"LunaticPal: Save BMP As", NULL, "*.bmp", ALLEGRO_FILECHOOSER_SAVE};
    if (!saveDialog.show(nulldisplay)) return false;
    if (saveDialog.getSelectedFileCount() != 1) return false;

    const char* dest = al_get_native_file_dialog_path(saveDialog.get(), 0);

    // todo handle sanity if >1 entry?
    int num = openDialog.getSelectedFileCount();
    for (int i = 0; i < num; ++i) {
        const char* path = al_get_native_file_dialog_path(openDialog.get(), i);
        convert_file(path, dest);
    }
    return true;
}

void perform_loop() {
    while(perform_once());
}
